#ifndef _SOCK_K_H
#define _SOCK_K_H
//head files

#ifdef __KERNEL__
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/netdevice.h>
#include <linux/skbuff.h>
#include <linux/netfilter_ipv4.h>
#include <linux/inet.h>
#include <linux/in.h>
#include <linux/ip.h>
#include <linux/netlink.h>
#include <linux/spinlock.h>
#include <net/sock.h>
#include "vttydef.h"

#define USERPROC 256
static struct sock *nlfd;	//netlink socket between kernel and user space
struct semaphore  receive_sem;
struct {
    __u32 pid;
    rwlock_t lock;
}user_proc[CF_MAXPORTS];
#endif  //__KERNEL__    END

//#define NL_PSEUDO      31	//netlink type

//message form
struct msg_info
{
#ifndef __KERNEL__
      struct nlmsghdr hdr;
#endif
	unsigned int comd;
	unsigned int len;
	unsigned char data[0];
};

#endif
